// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlAnimation")]
    pub struct Animation(Object<ffi::DzlAnimation, ffi::DzlAnimationClass>);

    match fn {
        type_ => || ffi::dzl_animation_get_type(),
    }
}

impl Animation {
    #[doc(alias = "dzl_animation_add_property")]
    pub fn add_property(&self, pspec: impl AsRef<glib::ParamSpec>, value: &glib::Value) {
        unsafe {
            ffi::dzl_animation_add_property(
                self.to_glib_none().0,
                pspec.as_ref().to_glib_none().0,
                value.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_animation_start")]
    pub fn start(&self) {
        unsafe {
            ffi::dzl_animation_start(self.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_animation_stop")]
    pub fn stop(&self) {
        unsafe {
            ffi::dzl_animation_stop(self.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_animation_calculate_duration")]
    pub fn calculate_duration(monitor: &gdk::Monitor, from_value: f64, to_value: f64) -> u32 {
        assert_initialized_main_thread!();
        unsafe {
            ffi::dzl_animation_calculate_duration(monitor.to_glib_none().0, from_value, to_value)
        }
    }

    #[doc(alias = "tick")]
    pub fn connect_tick<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn tick_trampoline<F: Fn(&Animation) + 'static>(
            this: *mut ffi::DzlAnimation,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"tick\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    tick_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for Animation {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Animation")
    }
}
